do
   include("console.lua")

   function test_clipping(obj, region, pt_in, pt_out)
      obj:setRegion(region)
      assert(isEqual(region, obj:getRegion()))
      foreach(pt_in,  function(i,v) assert(%obj:isInside(v),"Point "..i) end)
      foreach(pt_out, function(i,v) assert(not %obj:isInside(v),"Point "..i) end)
   end

   local clipping = lo_createproxy(readIOR("server.ref"),"TstClipping::Clipping")

   local region1 = { { {x = 0.0, y = 0.0}, {x = 1.0, y = 1.0} } }

   local points_in1 = {{x = 0.0, y = 0.0}, {x = 1.0, y = 1.0},
                       {x = 0.5, y = 0.5}, {x = 0.0, y = 0.5},
                       {x = 1.0, y = 0.5}, {x = 0.5, y = 0.0},
                       {x = 0.5, y = 1.0},
                      }

   local points_out1 = {{x = -0.5, y = -0.5}, {x = 1.5, y = 1.5},
                        {x = 0.5, y = 1.5}, {x = 1.5, y = 0.5},
                        {x = 1.0, y = 1.5}, {x = 0.0, y = 1.5},
                        {x = 1.5, y = 1.0}, {x = 1.5, y = 0.0}
                       }

   test_clipping(clipping, region1, points_in1, points_out1)

   local region2 = { { {x = 0.0, y = 0.0}, {x = 1.0, y = 1.0} },
                     { {x = -2.0, y = -2.0}, {x = -1.0, y = -1.0} }}

   local points_in2 = {{x = 0.0, y = 0.0}, {x = 1.0, y = 1.0},
                       {x = 0.5, y = 0.5}, {x = 0.0, y = 0.5},
                       {x = 1.0, y = 0.5}, {x = 0.5, y = 0.0},
                       {x = 0.5, y = 1.0},
                       {x = -2.0, y = -2.0}, {x = -1.0, y = -1.0},
                       {x = -1.5, y = -1.5}, {x = -2.0, y = -1.5},
                       {x = -1.0, y = -1.5}, {x = -1.5, y = -2.0},
                       {x = -1.5, y = -1.0},
                      }

   local points_out2 = {{x = -0.5, y = -0.5}, {x = 1.5, y = 1.5},
                        {x = 0.5, y = 1.5}, {x = 1.5, y = 0.5},
                        {x = 1.0, y = 1.5}, {x = 0.0, y = 1.5},
                        {x = 1.5, y = 1.0}, {x = 1.5, y = 0.0},
                        {x = -2.5, y = -2.5},
                        {x = -1.5, y = -0.5}, {x = -0.5, y = -1.5},
                        {x = -1.0, y = -0.5}, {x = -2.0, y = -0.5},
                        {x = -0.5, y = -1.0}, {x = -0.5, y = -2.0},
                       }

   test_clipping(clipping, region2, points_in2, points_out2)

   return "Ok"

end
