if not LuaOrbCfg.getIFR() or LuaOrbCfg.getIFR():_non_existent() then
   error("The Interface Repository is not available.")
end


function newDSIObject(interface_name)
   local servant = {obj = lo_createservant({},interface_name),
                    Install = function (self, opname, code)
                       local aux = "return " .. code
                       local method = dostring(aux)
                       if type(method) == "function" then
                          self.obj[opname] = method
                       end
                    end,
                   }
   return servant
end

function newLuaFactory()
   local obj = {list = {},
                Instance = function (self, interface_name)
                   local servant = newDSIObject(interface_name)
                   if not self.list[interface_name] then
                      self.list[interface_name] = {n=0}
                   end
                   local l = self.list[interface_name]
                   l.n = l.n + 1
                   l[l.n] = servant
                   return servant
                end,
               }
   return obj
end

do
   server = lo_createservant(newLuaFactory(),"Lua::DSIObjectFactory")
   writeto("./server.ref")
   write(server:_get_ior())
   writeto()
end
