#ifndef LUAORB_H
#define LUAORB_H

#define LUAORB_VERSION   "LuaOrb 2.0b"
#define LUAORB_COPYRIGHT "Copyright (C) 1996-2001 Tecgraf, PUC-Rio"
#define LUAORB_AUTHORS   "R. Cerqueira & A. Moura & L. Nogueira"

#ifndef LUAORB_API
#define LUAORB_API
#endif

#ifdef OB_INTEGER_VERSION   //if we are using ORBacus

#  if OB_INTEGER_VERSION >= 4000000L //if we are using ORBacus 4.0 or newer

LUAORB_API void luaorb_open(lua_State *L, CORBA::ORB_ptr the_Orb, 
	         PortableServer::POA_ptr the_POA, const char* name=NULL);

#  else //else we are using ORBacus 3.*

LUAORB_API void luaorb_open(lua_State *L, CORBA_ORB_ptr the_Orb, 
		 CORBA_BOA_ptr the_BOA, const char* name = NULL);

#  endif

#elif defined(MICO_VERSION) || defined(TAO_MASTER_CORBA_H) //else if we are using MICO or TAO

LUAORB_API void luaorb_open(lua_State *L, CORBA::ORB_ptr the_Orb, 
		 PortableServer::POA_ptr the_POA, const char* name=NULL);

#else //else we are using Visibroker 3.3

LUAORB_API void luaorb_open(lua_State *L, CORBA::ORB_ptr the_Orb, 
		 CORBA::BOA_ptr the_BOA, const char* name = NULL);

#endif

LUAORB_API void luaorb_close(lua_State *L);

#endif
