# ---------------------------------------------------------------------------
# Use the following lines to set your installation directories
# ---------------------------------------------------------------------------
INC_DIR = ./include
LIB_DIR = ./lib/mico-Linux
OBJ_DIR = ./obj/mico-Linux
BIN_DIR = ./bin/mico-Linux
SRC_DIR = ./src/library
DEMO_DIR = ./demo
DEMO_SRC_DIR = ./src/bin
DEMO_INC_DIR = ./src/bin


# ---------------------------------------------------------------------------
# Use the following lines to set the directories where Lua is installed
# ---------------------------------------------------------------------------
LUA_DIR = @lua_dir@
LUA_INC = $(LUA_DIR)/include
LUA_LIB = $(LUA_DIR)/lib

# ---------------------------------------------------------------------------
# Use the following lines to set the directories where Mico is installed
# ---------------------------------------------------------------------------
MICO_DIR = @orb_dir@
MICO_INC = $(MICO_DIR)/include
MICO_LIB = $(MICO_DIR)/lib

# ---------------------------------------------------------------------------
# Compiler options
# ---------------------------------------------------------------------------
CC = g++

INCS = -I$(MICO_INC) -I$(LUA_INC) -I$(INC_DIR) -I$(SRC_DIR)

# Comment the following line if you don't want debug information
@use_debug@ = -g

# Comment the following line if you don't want verbose outputs
@verbose@ = -DVERBOSE

CFLAGS = $(USE_DEBUG) -Wall -ftemplate-depth-42 -fpermissive $(INCS) -DCORBA_2_3 -DORB_MICO $(VERBOSE)

# ---------------------------------------------------------------------------
# Linker options
# ---------------------------------------------------------------------------

LFLAGS = -L$(LIB_DIR) -L$(LUA_LIB) -L$(MICO_LIB) -lluaorb -llua -llualib -lmico2.3.4 -ldl

# ---------------------------------------------------------------------------
# Target options
# ---------------------------------------------------------------------------
LOLIB = $(LIB_DIR)/libluaorb.a
LOCONSOLE = $(BIN_DIR)/luaorb

# ---------------------------------------------------------------------------
# Other definitions
# ---------------------------------------------------------------------------
SHELL = /bin/sh
