# ---------------------------------------------------------------------------
# Use the following lines to set your installation directories
# ---------------------------------------------------------------------------
INC_DIR = ./include
LIB_DIR = ./lib/ob3-$(OS_SYSTEM)
OBJ_DIR = ./obj/ob3-$(OS_SYSTEM)
SRC_DIR = ./src/library
DEMO_DIR = ./demo
DEMO_SRC_DIR = ./src/bin
DEMO_INC_DIR = ./src/bin

# ---------------------------------------------------------------------------
# Use the following lines to set the directories where Lua is installed
# ---------------------------------------------------------------------------
LUA_DIR = /home/c/corba/lua
LUA_INC = $(LUA_DIR)/include
LUA_LIB = $(LUA_DIR)/lib

# ---------------------------------------------------------------------------
# Use the following lines to set the directories where ORBacus is installed
# ---------------------------------------------------------------------------
OB_DIR = /home/c/corba/orbacus/OB-3.1/ob
OB_INC = $(OB_DIR)/include
OB_LIB = $(OB_DIR)/lib

# ---------------------------------------------------------------------------
# Use the following lines to set the directories where JTC is installed,
# and the required options to compile and link with JTC
# Note: LuaOrb does not require JTC, so you can comment these lines.
# You only need the settings below if your ORBacus library was compiled with JTC
# ---------------------------------------------------------------------------
#JTC_DIR = /home/corba/ooc/jtc/jtc
#JTC_INC = $(JTC_DIR)/include
#JTC_LIB = $(JTC_DIR)/lib
#USE_JTC_INC = -I$(JTC_INC)
#USE_JTC_LIB = -L$(JTC_LIB) -lJTC -lpthread

# ---------------------------------------------------------------------------
# Compiler options
# ---------------------------------------------------------------------------
CC = CC

INCS = -I$(OB_INC) -I$(LUA_INC) -I$(INC_DIR) -I$(SRC_DIR) $(USE_JTC_INC)

# Comment the following line if you don't want debug information
USE_DEBUG = -g

# Comment the following line if you don't want verbose outputs
#VERBOSE = -DVERBOSE


CFLAGS = $(USE_DEBUG) $(INCS) -DORB_ORBACUS $(VERBOSE)

# ---------------------------------------------------------------------------
# Linker options
# ---------------------------------------------------------------------------

LFLAGS = -L$(LIB_DIR) -L$(LUA_LIB) -L$(OB_LIB) -lluaorb -llua -llualib -lOB -lsocket $(USE_JTC_LIB)

# ---------------------------------------------------------------------------
# Target options
# ---------------------------------------------------------------------------
LOLIB = $(LIB_DIR)/libluaorb.a
DEMO = $(DEMO_DIR)/luaorb

# ---------------------------------------------------------------------------
# Other definitions
# ---------------------------------------------------------------------------
SHELL = /bin/sh
