# ---------------------------------------------------------------------------
# Use the following lines to set your installation directories
# ---------------------------------------------------------------------------
INC_DIR = .\include
LIB_DIR = .\lib
OBJ_DIR = .\obj
BIN_DIR = .\bin
SRC_DIR = .\src\library
DEMO_DIR = .\demo
DEMO_SRC_DIR = .\src\bin
DEMO_INC_DIR = .\src\bin

# ---------------------------------------------------------------------------
# Use the following lines to set the directories where Lua is installed
# ---------------------------------------------------------------------------
LUA_DIR = @lua_dir@
LUA_INC = $(LUA_DIR)\include
LUA_LIB = $(LUA_DIR)\lib

# ----------------------------------------------------------------------------
# Use the following lines to set the directories where Visibroker is installed
# ----------------------------------------------------------------------------
VB_DIR = @orb_dir@
VB_INC = $(VB_DIR)\include
VB_LIB = $(VB_DIR)\lib

# ---------------------------------------------------------------------------
# Compiler options
# ---------------------------------------------------------------------------
CC = CL

INCS = -I$(VB_INC) -I$(LUA_INC) -I$(INC_DIR) -I$(SRC_DIR)

# If you don't want debug information, comment the following line and
# uncomment the next one.
@use_debug@ = /Zi /Od /Yd

# Comment the following line if you don't want verbose outputs
@verbose@ = -DVERBOSE

CFLAGS = /GX /GR /ML $(USE_DEBUG) $(INCS) -DWIN32 -DORB_VISIBROKER -D_VIS_INCLUDE_DSI $(VERBOSE)

.SUFFIXES:
.SUFFIXES: .cpp .obj

# ---------------------------------------------------------------------------
# Linker options
# ---------------------------------------------------------------------------
DEFAULT_LIBS = kernel32.lib user32.lib shell32.lib wsock32.lib

LFLAGS = /nologo /subsystem:console /incremental:no /machine:I386 $(LOLIB) $(LUA_LIB)/lua.lib $(LUA_LIB)/lualib.lib $(VB_LIB)/orb.lib $(DEFAULT_LIBS)

# ---------------------------------------------------------------------------
# Target options
# ---------------------------------------------------------------------------
LOLIB = $(LIB_DIR)\luaorb.lib
LOCONSOLE = $(BIN_DIR)\luaorb.exe
