include ./config.mak

all: lo_lib lo_bin
lo_lib: $(LIB_DIR) $(OBJ_DIR) $(LOLIB)
lo_bin: $(OBJ_DIR) $(BIN_DIR) $(LOCONSOLE)

$(LIB_DIR)::
	if not exist $(LIB_DIR) \
	   mkdir $(LIB_DIR)

$(OBJ_DIR)::
	if not exist $(OBJ_DIR) \
	   mkdir $(OBJ_DIR)

$(BIN_DIR)::
	if not exist $(BIN_DIR) \
	   mkdir $(BIN_DIR)

clean-obj:
	del $(OBJ_DIR)\*.obj 
	rmdir $(OBJ_DIR)

clean:
	del $(OBJ_DIR)\*.obj 
	rmdir $(OBJ_DIR)
	del $(LIB_DIR)\*.lib 
	rmdir $(LIB_DIR)
	del $(BIN_DIR)\*.exe 
	rmdir $(BIN_DIR)

LIB_OBJS = $(OBJ_DIR)/lo_proxy.obj $(OBJ_DIR)/lo_map.obj $(OBJ_DIR)/lo_tcode.obj $(OBJ_DIR)/lo_cfg.obj $(OBJ_DIR)/lo_dsi.obj $(OBJ_DIR)/luawrap.obj $(OBJ_DIR)/luaorb.obj $(OBJ_DIR)/lo_class.obj $(OBJ_DIR)/lo_util.obj

$(LOLIB): $(LIB_OBJS)
	lib /NOLOGO /OUT:$@ $(LIB_OBJS)


{$(SRC_DIR)}.cpp{$(OBJ_DIR)}.obj:
	$(CC) /c $(CFLAGS) /Fo$@ $<

{$(DEMO_SRC_DIR)}.cpp{$(OBJ_DIR)}.obj:
	$(CC) /c $(CFLAGS) /Fo$@ $<

BIN_OBJS = $(OBJ_DIR)/consolewin-ob3.obj $(OBJ_DIR)/wreactor-ob3.obj $(OBJ_DIR)/utils.obj $(OBJ_DIR)/cotimer.obj $(LOLIB)

$(LOCONSOLE): $(BIN_OBJS)
	link /out:$@ $(BIN_OBJS) $(LFLAGS)

include ./mak/dependences.mak

