include ./config.mak

all: lo_lib lo_bin
lo_lib: $(LIB_DIR) $(OBJ_DIR) $(LOLIB)
lo_bin: $(OBJ_DIR) $(BIN_DIR) $(LOCONSOLE)

clean-obj:
	@rm -fR $(OBJ_DIR)

clean:
	@rm -fR $(OBJ_DIR) $(LIB_DIR) $(BIN_DIR)

$(LIB_DIR):
	@if [ ! -d $@ ] ; then mkdir -p $@ ; fi

$(BIN_DIR):
	@if [ ! -d $@ ] ; then mkdir -p $@ ; fi

$(OBJ_DIR):
	@if [ ! -d $@ ] ; then mkdir -p $@ ; fi

$(LOLIB): $(OBJ_DIR)/lo_proxy.o $(OBJ_DIR)/lo_map.o $(OBJ_DIR)/lo_tcode.o $(OBJ_DIR)/lo_cfg.o $(OBJ_DIR)/lo_dsi.o $(OBJ_DIR)/luawrap.o $(OBJ_DIR)/luaorb.o $(OBJ_DIR)/lo_class.o $(OBJ_DIR)/lo_util.o
	ar r $@ $?
	ranlib $@

$(OBJ_DIR)/%.o : $(SRC_DIR)/%.cpp
	$(CC) -c $(CFLAGS) -o $@ $<

$(SRC_DIR)/%.cpp : $(SRC_DIR)/RCS/%.cpp,v
	co $< $@

$(SRC_DIR)/%.h : $(SRC_DIR)/RCS/%.h,v
	co $< $@

$(OBJ_DIR)/%.o : $(DEMO_SRC_DIR)/%.cpp
	$(CC) -c $(CFLAGS) -o $@ $<

$(LOCONSOLE): $(OBJ_DIR)/console-ob4.o $(OBJ_DIR)/kreactor-ob4.o $(OBJ_DIR)/utils.o $(LOLIB)
	$(CC) -o $@ $(OBJ_DIR)/console-ob4.o $(OBJ_DIR)/kreactor-ob4.o $(OBJ_DIR)/utils.o $(LFLAGS)

include ./mak/dependences.mak

