//*****************************************************************************
//
// LuaOrb Library
// Computer Science Department of PUC-Rio
// Rio de Janeiro, Brazil
//
// $Id: lo_cfg.h,v 1.10.2.1 2001/08/07 13:33:02 moura Exp $
//
//*****************************************************************************


#ifndef LO_CFG_H
#define LO_CFG_H

class LuaProxy;

enum ConfigurableMode { VERBOSE_MODE,
		        ENUM_NUMERIC_MODE, 
                        SERVANT_OPTIMIZATION,
			OCTETSEQ_AS_STRING };

class LuaOrbCfg
{
   static const char* reg_LuaOrbCfg;
   static const char* reg_NewServantTagTable;

public:

   char *state_name;

   CORBA::ORB_ptr orb;
   CORBA::Repository_ptr orb_ir;

#ifdef CORBA_2_3
   PortableServer::POA_ptr poa;
   PortableServer::POA_ptr persistent_poa;
   DynamicAny::DynAnyFactory_ptr orb_dynany_factory;

   LuaOrbCfg(lua_State *L, CORBA::ORB_ptr _orb, 
	     PortableServer::POA_ptr root_poa, const char* name);
#else
   CORBA::BOA_ptr boa;

   LuaOrbCfg(lua_State *L, CORBA::ORB_ptr _orb, 
	     CORBA::BOA_ptr boa, const char* name);
#endif

   ~LuaOrbCfg();

   static LuaOrbCfg* getConfiguration(lua_State *L);
   static int modeConfigured(lua_State *L, ConfigurableMode mode);

   static void getNewServantTagMethod(lua_State *L, int tag);
   static void setNewServantTagMethod(lua_State *L, int pos, int tag); 

#ifdef CORBA_2_3
   static void open(lua_State *L, CORBA::ORB_ptr orb, 
                    PortableServer::POA_ptr poa, const char* name);
#else
   static void open(lua_State *L, CORBA::ORB_ptr orb, CORBA::BOA_ptr boa,
                    const char* name);
#endif

   static void close(lua_State *L);

};
#endif
