#include <stdlib.h>
extern "C" {
#include <lua.h>
};

#include "orb_inc.h"
#include "lo_cfg.h"
#include "lo_util.h"

int LuaOrbUtil::isCallable(lua_State *L, int pos)
{
   if (lua_isfunction(L, pos))
      return 1;
   if (lua_istable(L, pos) || lua_isuserdata(L, pos))
   {
      lua_gettagmethod(L, lua_tag(L, pos), "function");
      int res = lua_isfunction(L, -1);
      lua_pop(L, 1);
      return res;
   }
   return 0;
}

int LuaOrbUtil::isIndexable(lua_State *L, int pos)
{
   if (lua_istable(L, pos))
      return 1;
   if (lua_isuserdata(L, pos))
   {
      int tag = lua_tag(L, pos);
      lua_gettagmethod(L, tag,"gettable");
      lua_gettagmethod(L, tag,"settable");
      int top = lua_gettop(L);
      int res = LuaOrbUtil::isCallable(L, top) 
	        && LuaOrbUtil::isCallable(L, top-1);
      lua_pop(L, 2);
      return res;
   }
   return 0;
}

int LuaOrbUtil::isRepositoryId(const char* interface_name)
{
   if (interface_name[0] == 'I' && interface_name[1] == 'D' &&
       interface_name[2] == 'L' && interface_name[3] == ':' &&
       interface_name[4] != ':')
      return 1;
   else
      return 0;
}

char* LuaOrbUtil::getRepositoryId(lua_State *L, CORBA::Object_ptr obj)
{
   LuaOrbCfg* loCfg = LuaOrbCfg::getConfiguration(L);

   char* _interface = NULL;
   char* ior = loCfg->orb->object_to_string(obj);
   char* aux = strstr(ior,"49444c3a");
   if (aux)
   {
      const int max_size = 200;
      char* buffer = (char*) malloc(max_size*sizeof(char));
      char c[5];
      c[0] = '0'; c[1] = 'x'; c[4] = '\0';
      for (int i =0; aux[i] && i/2 < max_size; i+=2)
      {
         c[2] = aux[i]; c[3] = aux[i+1];
         if (c[2] == '0' && c[3] == '0')
         {
            buffer[i/2] = '\0';
            _interface = buffer;
            buffer = NULL;
            break;
         }
         else
         {
            buffer[i/2] = (char) strtol(c,NULL,16);
         }
      }
      if (_interface == NULL)
         free(buffer);
   }
   CORBA::string_free(ior);
   return _interface;
}
