#ifndef LO_UTIL_H
#define LO_UTIL_H

class LuaOrbUtil
{
public:
   /** Tests if a Lua object can be indexed
   *   (so it can be used for server implementation)
   */
   static int isIndexable(lua_State *L, int pos);

   /** Tests if a Lua object is a function or has a "function" tag method
   */
   static int isCallable(lua_State *L, int pos);

   /** Tests if a string is a Interface Repository ID
   */
   static int isRepositoryId(const char* interface_name);

   /** Parses an object's IOR for getting its interface ID
   */
   static char* getRepositoryId(lua_State *L, CORBA::Object_ptr obj);
};
#endif
