//*****************************************************************************
//
// LuaOrb Library
// Computer Science Department of PUC-Rio
// Rio de Janeiro, Brazil
//
// $Id: luaorb.cpp,v 1.7.2.3 2001/12/04 00:56:36 rcerq Exp $
//
//*****************************************************************************


extern "C"
{
#include <lua.h>
}

#include "orb_inc.h"
#include "luaorb.h"
#include "lo_proxy.h"
#include "lo_dsi.h"
#include "lo_tcode.h"
#include "lo_cfg.h"
#include "lo_class.h"

#ifdef CORBA_2_3
LUAORB_API void luaorb_open(lua_State *L, CORBA::ORB_ptr the_Orb, 
                 PortableServer::POA_ptr the_OA, const char* name)
#else
LUAORB_API void luaorb_open(lua_State *L, CORBA::ORB_ptr the_Orb, 
                 CORBA::BOA_ptr the_OA, const char* name)
#endif

{
   LuaOrbCfg::open(L,the_Orb,the_OA,name);
   LuaProxy::open(L);
   LuaDSI::open(L);
   LuaTypeCode::open(L);
}

LUAORB_API void luaorb_close(lua_State *L)
{
   LuaProxy::close(L);
   LuaDSI::close(L);
   LuaOrbClass::close(L);
   LuaOrbCfg::close(L);
}
