//*****************************************************************************
//
// LuaOrb Library
// Computer Science Department of PUC-Rio
// Rio de Janeiro, Brazil
//
// $Id: luawrap.h,v 1.4.2.1 2001/08/07 13:33:03 moura Exp $
//
//*****************************************************************************

#ifndef LUAWRAPPER_H
#define LUAWRAPPER_H

class LuaWrapper
{
   struct MethodsList
   {
      int n;
      struct luaL_reg* table;
   };

   int tag;
   int ud_tag;
   char* tag_name;
   MethodsList* mlist;

protected:
   static const char*  reg_WRAPPER_TAG;
   LuaWrapper( lua_State *L, const char* name );

public:
   static LuaWrapper* createWrapper(lua_State *L, const char* name);
   static LuaWrapper* getWrapper(lua_State *L, const char* name);
   static void deleteWrapper(lua_State *L, const char* name);

   virtual ~LuaWrapper();

   void  reg_tagmethods(lua_State *L, struct luaL_reg* table, int n);
   void  reg_ud_tagmethods(lua_State *L, struct luaL_reg* table, int n);
   void  reg_methods(struct luaL_reg* table, int n);
   void  push(lua_State *L, void* userdata);
   void* check_tag(lua_State *L, int narg);
   void* from_lua(lua_State *L, int pos);
};
#endif
